diff --git a/ldap/servers/slapd/back-ldbm/ldif2ldbm.c b/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
index ab794a189..3df164be6 100644
--- a/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
+++ b/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
@@ -1060,606 +757,79 @@ export_one_entry(struct ldbminfo *li,
     rc = write(expargs->fd, data.data, len);
     PR_ASSERT(rc > 0);
     rc = write(expargs->fd, "\n", 1);
-    PR_ASSERT(rc > 0);
-    rc = 0;
-    if ((*expargs->cnt) % 1000 == 0) {
-        int percent;
-
-        if (expargs->idl) {
-            percent = (expargs->idindex * 100 / expargs->idl->b_nids);
-        } else {
-            percent = (expargs->ep->ep_id * 100 / expargs->lastid);
-        }
-        if (expargs->task) {
-            slapi_task_log_status(expargs->task,
-                                  "%s: Processed %d entries (%d%%).",
-                                  inst->inst_name, *expargs->cnt, percent);
-            slapi_task_log_notice(expargs->task,
-                                  "%s: Processed %d entries (%d%%).",
-                                  inst->inst_name, *expargs->cnt, percent);
-        }
-        slapi_log_err(SLAPI_LOG_INFO, "export_one_entry", "export %s: Processed %d entries (%d%%).\n",
-                      inst->inst_name, *expargs->cnt, percent);
-        *expargs->lastcnt = *expargs->cnt;
-    }
-bail:
-    slapi_ch_free(&(data.data));
-    return rc;
-}
-
-/*
- * ldbm_back_ldbm2ldif - backend routine to convert database to an
- * ldif file.
- * (reunified at last)
- */
-#define LDBM2LDIF_BUSY (-2)
-int
-ldbm_back_ldbm2ldif(Slapi_PBlock *pb)
-{
-    backend *be = NULL;
-    struct ldbminfo *li = NULL;
-    DB *db = NULL;
-    DBC *dbc = NULL;
-    struct backentry *ep;
-    DBT key = {0};
-    DBT data = {0};
-    char *fname = NULL;
-    int printkey, rc, ok_index;
-    int return_value = 0;
-    int nowrap = 0;
-    int nobase64 = 0;
-    NIDS idindex = 0;
-    ID temp_id;
-    char **exclude_suffix = NULL;
-    char **include_suffix = NULL;
-    int decrypt = 0;
-    int32_t dump_replica = 0;
-    int dump_uniqueid = 1;
-    int fd = STDOUT_FILENO;
-    IDList *idl = NULL; /* optimization for -s include lists */
-    int cnt = 0, lastcnt = 0;
-    int options = 0;
-    int keepgoing = 1;
-    int isfirst = 1;
-    int appendmode = 0;
-    int appendmode_1 = 0;
-    int noversion = 0;
-    ID lastid = 0;
-    int task_flags;
-    Slapi_Task *task;
-    int run_from_cmdline = 0;
-    char *instance_name;
-    ldbm_instance *inst = NULL;
-    int str2entry_options = 0;
-    int retry;
-    int we_start_the_backends = 0;
-    static int load_dse = 1; /* We'd like to load dse just once. */
-    int server_running;
-    export_args eargs = {0};
-
-    slapi_log_err(SLAPI_LOG_TRACE, "ldbm_back_ldbm2ldif", "=>\n");
-
-    slapi_pblock_get(pb, SLAPI_PLUGIN_PRIVATE, &li);
-    slapi_pblock_get(pb, SLAPI_TASK_FLAGS, &task_flags);
-    slapi_pblock_get(pb, SLAPI_DB2LDIF_DECRYPT, &decrypt);
-    slapi_pblock_get(pb, SLAPI_DB2LDIF_SERVER_RUNNING, &server_running);
-    run_from_cmdline = (task_flags & SLAPI_TASK_RUNNING_FROM_COMMANDLINE);
-
-    dump_replica = slapi_pblock_get_ldif_dump_replica(pb);
-    if (run_from_cmdline) {
-        li->li_flags |= SLAPI_TASK_RUNNING_FROM_COMMANDLINE;
-        if (!dump_replica) {
-            we_start_the_backends = 1;
-        }
-    }
-
-    if (we_start_the_backends && load_dse) {
-        /* No ldbm be's exist until we process the config information. */
-
-        /*
-         * Note that we should only call this once. If we're
-         * dumping several backends then it gets called multiple
-         * times and we get warnings in the error log like this:
-         *   WARNING: ldbm instance userRoot already exists
-         */
-        ldbm_config_load_dse_info(li);
-        load_dse = 0;
-    }
-
-    if (run_from_cmdline && li->li_dblayer_private->dblayer_private_mem && server_running) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "ldbm_back_ldbm2ldif", "Cannot export the database while the server "
-                                             "is running and nsslapd-db-private-mem option is used, please use ldif2db.pl\n");
-        return_value = -1;
-        goto bye;
-    }
-
-    if (run_from_cmdline) {
-
-        /* Now that we have processed the config information, we look for
-         * the be that should do the db2ldif. */
-        slapi_pblock_get(pb, SLAPI_BACKEND_INSTANCE_NAME, &instance_name);
-        inst = ldbm_instance_find_by_name(li, instance_name);
-        if (NULL == inst) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "Unknown backend instance %s\n",
-                          instance_name);
-            return_value = -1;
-            goto bye;
-        }
-        /* [605974] command db2ldif should not be able to run when on-line
-         * import is running */
-        if (dblayer_in_import(inst)) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "Backend instance %s is busy\n",
-                          instance_name);
-            return_value = -1;
-            goto bye;
-        }
-
-        /* store the be in the pb */
-        be = inst->inst_be;
-        slapi_pblock_set(pb, SLAPI_BACKEND, be);
-    } else {
-        slapi_pblock_get(pb, SLAPI_BACKEND, &be);
-        if (!be) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "No backend\n");
-            return_value = -1;
-            goto bye;
-        }
-        inst = (ldbm_instance *)be->be_instance_info;
-        if (!inst) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "Unknown backend instance\n");
-            return_value = -1;
-            goto bye;
-        }
-
-        /* check if an import/restore is already ongoing... */
-        if (instance_set_busy(inst) != 0) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "Backend instance '%s' is already in the middle"
-                                                                " of another task and cannot be disturbed.\n",
-                          inst->inst_name);
-            return_value = LDBM2LDIF_BUSY;
-            goto bye;
-        }
-    }
-
-    slapi_pblock_get(pb, SLAPI_BACKEND_TASK, &task);
-
-    ldbm_back_fetch_incl_excl(pb, &include_suffix, &exclude_suffix);
-
-    str2entry_options = (dump_replica ? 0 : SLAPI_STR2ENTRY_TOMBSTONE_CHECK);
-
-    slapi_pblock_get(pb, SLAPI_DB2LDIF_FILE, &fname);
-    slapi_pblock_get(pb, SLAPI_DB2LDIF_PRINTKEY, &printkey);
-    slapi_pblock_get(pb, SLAPI_DB2LDIF_DUMP_UNIQUEID, &dump_uniqueid);
-
-    /* tsk, overloading printkey.  shame on me. */
-    ok_index = !(printkey & EXPORT_ID2ENTRY_ONLY);
-    printkey &= ~EXPORT_ID2ENTRY_ONLY;
-
-    nobase64 = (printkey & EXPORT_MINIMAL_ENCODING);
-    printkey &= ~EXPORT_MINIMAL_ENCODING;
-    nowrap = (printkey & EXPORT_NOWRAP);
-    printkey &= ~EXPORT_NOWRAP;
-    appendmode = (printkey & EXPORT_APPENDMODE);
-    printkey &= ~EXPORT_APPENDMODE;
-    appendmode_1 = (printkey & EXPORT_APPENDMODE_1);
-    printkey &= ~EXPORT_APPENDMODE_1;
-    noversion = (printkey & EXPORT_NOVERSION);
-    printkey &= ~EXPORT_NOVERSION;
-
-    /* decide whether to dump uniqueid */
-    if (dump_uniqueid)
-        options |= SLAPI_DUMP_UNIQUEID;
-    if (nowrap)
-        options |= SLAPI_DUMP_NOWRAP;
-    if (nobase64)
-        options |= SLAPI_DUMP_MINIMAL_ENCODING;
-    if (dump_replica)
-        options |= SLAPI_DUMP_STATEINFO;
-
-    if (fname == NULL) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "db2ldif: no LDIF filename supplied\n");
-        return_value = -1;
-        goto bye;
-    }
-
-    if (strcmp(fname, "-")) { /* not '-' */
-        if (appendmode) {
-            if (appendmode_1) {
-                fd = dblayer_open_huge_file(fname, O_WRONLY | O_CREAT | O_TRUNC,
-                                            SLAPD_DEFAULT_FILE_MODE);
-            } else {
-                fd = dblayer_open_huge_file(fname, O_WRONLY | O_CREAT | O_APPEND,
-                                            SLAPD_DEFAULT_FILE_MODE);
-            }
-        } else {
-            /* open it */
-            fd = dblayer_open_huge_file(fname, O_WRONLY | O_CREAT | O_TRUNC,
-                                        SLAPD_DEFAULT_FILE_MODE);
-        }
-        if (fd < 0) {
-            slapdFrontendConfig_t *slapdFrontendConfig = getFrontendConfig();
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "db2ldif: can't open %s: %d (%s) while running as user \"%s\"\n",
-                          fname, errno, dblayer_strerror(errno), slapdFrontendConfig->localuserinfo->pw_name);
-            return_value = -1;
-            goto bye;
-        }
-    } else { /* '-' */
-        fd = STDOUT_FILENO;
-    }
-
-    if (we_start_the_backends) {
-        if (0 != dblayer_start(li, DBLAYER_EXPORT_MODE)) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "db2ldif: Failed to init database\n");
-            return_value = -1;
-            goto bye;
-        }
-        /* dblayer_instance_start will init the id2entry index. */
-        if (0 != dblayer_instance_start(be, DBLAYER_EXPORT_MODE)) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "db2ldif: Failed to init instance\n");
-            return_value = -1;
-            goto bye;
-        }
-    }
-
-    /* idl manipulation requires nextid to be init'd now */
-    if (include_suffix && ok_index)
-        get_ids_from_disk(be);
-
-    if (((dblayer_get_id2entry(be, &db)) != 0) || (db == NULL)) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "Could not open/create id2entry\n");
-        return_value = -1;
-        goto bye;
-    }
-
-    /* if an include_suffix was given (and we're pretty sure the
-     * entrydn and ancestorid indexes are valid), we try to
-     * assemble an id-list of candidates instead of plowing thru
-     * the whole database.  this is a big performance improvement
-     * when exporting config info (which is usually on the order
-     * of 100 entries) from a database that may be on the order of
-     * GIGS in size.
-     */
-    {
-        /* Here, we assume that the table is ordered in EID-order,
-         * which it is !
-         */
-        /* get a cursor to we can walk over the table */
-        return_value = db->cursor(db, NULL, &dbc, 0);
-        if (0 != return_value || NULL == dbc) {
-            slapi_log_err(SLAPI_LOG_ERR,
-                          "ldbm_back_ldbm2ldif", "Failed to get cursor for db2ldif; %s (%d)\n",
-                          dblayer_strerror(return_value), return_value);
-            return_value = -1;
-            goto bye;
-        }
-        key.flags = DB_DBT_MALLOC;
-        data.flags = DB_DBT_MALLOC;
-        return_value = dbc->c_get(dbc, &key, &data, DB_LAST);
-        if (0 != return_value) {
-            keepgoing = 0;
-        } else {
-            lastid = id_stored_to_internal((char *)key.data);
-            slapi_ch_free(&(key.data));
-            slapi_ch_free(&(data.data));
-            isfirst = 1;
-        }
-    }
-    if (include_suffix && ok_index && !dump_replica) {
-        int err;
-
-        idl = ldbm_fetch_subtrees(be, include_suffix, &err);
-        if (NULL == idl) {
-            if (err) {
-                /* most likely, indexes are bad. */
-                slapi_log_err(SLAPI_LOG_ERR,
-                              "ldbm_back_ldbm2ldif", "Failed to fetch subtree lists (error %d) %s\n",
-                              err, dblayer_strerror(err));
-                slapi_log_err(SLAPI_LOG_ERR,
-                              "ldbm_back_ldbm2ldif", "Possibly the entrydn/entryrdn or ancestorid index is "
-                                                     "corrupted or does not exist.\n");
-                slapi_log_err(SLAPI_LOG_ERR,
-                              "ldbm_back_ldbm2ldif", "Attempting direct unindexed export instead.\n");
-            }
-            ok_index = 0;
-            idl = NULL;
-        } else if (ALLIDS(idl)) {
-            /* allids list is no help at all -- revert to trawling
-             * the whole list. */
-            ok_index = 0;
-            idl_free(&idl);
-        }
-        idindex = 0;
-    }
-
-    /* When user has specifically asked not to print the version
-     * or when this is not the first backend that is append into
-     * this file : don't print the version
-     */
-    if ((!noversion) && ((!appendmode) || (appendmode_1))) {
-        char vstr[64];
-        int myversion = 1; /* XXX: ldif version;
-                 * needs to be modified when version
-                 * control begins.
-                 */
-
-        sprintf(vstr, "version: %d\n\n", myversion);
-        rc = write(fd, vstr, strlen(vstr));
-        PR_ASSERT(rc > 0);
-        rc = 0;
-    }
-
-    eargs.decrypt = decrypt;
-    eargs.options = options;
-    eargs.printkey = printkey;
-    eargs.idl = idl;
-    eargs.lastid = lastid;
-    eargs.fd = fd;
-    eargs.task = task;
-    eargs.include_suffix = include_suffix;
-    eargs.exclude_suffix = exclude_suffix;
-
-    while (keepgoing) {
-        /*
-         * All database operations in a transactional environment,
-         * including non-transactional reads can receive a return of
-         * DB_LOCK_DEADLOCK. Which operation gets aborted depends
-         * on the deadlock detection policy, but can include
-         * non-transactional reads (in which case the single
-         * operation should just be retried).
-         */
-
-        if (idl) {
-            /* exporting from an ID list */
-            if (idindex >= idl->b_nids)
-                break;
-            id_internal_to_stored(idl->b_ids[idindex], (char *)&temp_id);
-            key.data = (char *)&temp_id;
-            key.size = sizeof(temp_id);
-            data.flags = DB_DBT_MALLOC;
-
-            for (retry = 0; retry < RETRY_TIMES; retry++) {
-                return_value = db->get(db, NULL, &key, &data, 0);
-                if (return_value != DB_LOCK_DEADLOCK)
-                    break;
-            }
-            if (return_value) {
-                slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_ldbm2ldif", "db2ldif: failed to read "
-                                                                    "entry %lu, err %d\n",
-                              (u_long)idl->b_ids[idindex],
-                              return_value);
-                return_value = -1;
-                break;
-            }
-            /* back to internal format: */
-            temp_id = idl->b_ids[idindex];
-            idindex++;
-        } else {
-            /* follow the cursor */
-            key.flags = DB_DBT_MALLOC;
-            data.flags = DB_DBT_MALLOC;
-            if (isfirst) {
-                for (retry = 0; retry < RETRY_TIMES; retry++) {
-                    return_value = dbc->c_get(dbc, &key, &data, DB_FIRST);
-                    if (return_value != DB_LOCK_DEADLOCK)
-                        break;
-                }
-                isfirst = 0;
-            } else {
-                for (retry = 0; retry < RETRY_TIMES; retry++) {
-                    return_value = dbc->c_get(dbc, &key, &data, DB_NEXT);
-                    if (return_value != DB_LOCK_DEADLOCK)
-                        break;
-                }
-            }
-
-            if (0 != return_value)
-                break;
-
-            /* back to internal format */
-            temp_id = id_stored_to_internal((char *)key.data);
-            slapi_ch_free(&(key.data));
-        }
-        if (idl_id_is_in_idlist(eargs.pre_exported_idl, temp_id)) {
-            /* it's already exported */
-            slapi_ch_free(&(data.data));
-            continue;
-        }
-
-        /* call post-entry plugin */
-        plugin_call_entryfetch_plugins((char **)&data.dptr, &data.dsize);
-
-        ep = backentry_alloc();
-        if (entryrdn_get_switch()) {
-            char *rdn = NULL;
-
-            /* rdn is allocated in get_value_from_string */
-            rc = get_value_from_string((const char *)data.dptr, "rdn", &rdn);
-            if (rc) {
-                /* data.dptr may not include rdn: ..., try "dn: ..." */
-                ep->ep_entry = slapi_str2entry(data.dptr,
-                                               str2entry_options | SLAPI_STR2ENTRY_NO_ENTRYDN);
-            } else {
-                char *pid_str = NULL;
-                char *pdn = NULL;
-                ID pid = NOID;
-                char *dn = NULL;
-                struct backdn *bdn = NULL;
-                Slapi_RDN psrdn = {0};
-
-                /* get a parent pid */
-                rc = get_value_from_string((const char *)data.dptr,
-                                           LDBM_PARENTID_STR, &pid_str);
-                if (rc) {
-                    rc = 0; /* assume this is a suffix */
-                } else {
-                    pid = (ID)strtol(pid_str, (char **)NULL, 10);
-                    slapi_ch_free_string(&pid_str);
-                    /* if pid is larger than the current pid temp_id,
-                     * the parent entry has to be exported first. */
-                    if (temp_id < pid &&
-                        !idl_id_is_in_idlist(eargs.pre_exported_idl, pid)) {
-
-                        eargs.idindex = idindex;
-                        eargs.cnt = &cnt;
-                        eargs.lastcnt = &lastcnt;
-
-                        rc = _export_or_index_parents(inst, db, NULL, temp_id,
-                                                      rdn, temp_id, pid, run_from_cmdline,
-                                                      &eargs, DB2LDIF_ENTRYRDN, &psrdn);
-                        if (rc) {
-                            slapi_rdn_done(&psrdn);
-                            backentry_free(&ep);
-                            continue;
-                        }
-                    }
-                }
-
-                bdn = dncache_find_id(&inst->inst_dncache, temp_id);
-                if (bdn) {
-                    /* don't free dn */
-                    dn = (char *)slapi_sdn_get_dn(bdn->dn_sdn);
-                    CACHE_RETURN(&inst->inst_dncache, &bdn);
-                    slapi_rdn_done(&psrdn);
-                } else {
-                    int myrc = 0;
-                    Slapi_DN *sdn = NULL;
-                    rc = entryrdn_lookup_dn(be, rdn, temp_id, &dn, NULL, NULL);
-                    if (rc) {
-                        /* We cannot use the entryrdn index;
-                         * Compose dn from the entries in id2entry */
-                        slapi_log_err(SLAPI_LOG_TRACE,
-                                      "ldbm_back_ldbm2ldif", "entryrdn is not available; "
-                                                             "composing dn (rdn: %s, ID: %d)\n",
-                                      rdn, temp_id);
-                        if (NOID != pid) { /* if not a suffix */
-                            if (NULL == slapi_rdn_get_rdn(&psrdn)) {
-                                /* This time just to get the parents' rdn
-                                 * most likely from dn cache. */
-                                rc = _get_and_add_parent_rdns(be, db, NULL, pid,
-                                                              &psrdn, NULL, 0,
-                                                              run_from_cmdline, NULL);
-                                if (rc) {
-                                    slapi_log_err(SLAPI_LOG_WARNING,
-                                                  "ldbm_back_ldbm2ldif", "Skip ID %d\n", pid);
-                                    slapi_ch_free_string(&rdn);
-                                    slapi_rdn_done(&psrdn);
-                                    backentry_free(&ep);
-                                    continue;
-                                }
-                            }
-                            /* Generate DN string from Slapi_RDN */
-                            rc = slapi_rdn_get_dn(&psrdn, &pdn);
-                            if (rc) {
-                                slapi_log_err(SLAPI_LOG_WARNING,
-                                              "ldbm_back_ldbm2ldif", "Failed to compose dn for "
-                                                                     "(rdn: %s, ID: %d) from Slapi_RDN\n",
-                                              rdn, temp_id);
-                                slapi_ch_free_string(&rdn);
-                                slapi_rdn_done(&psrdn);
-                                backentry_free(&ep);
-                                continue;
-                            }
-                        }
-                        dn = slapi_ch_smprintf("%s%s%s",
-                                               rdn, pdn ? "," : "", pdn ? pdn : "");
-                        slapi_ch_free_string(&pdn);
-                    }
-                    slapi_rdn_done(&psrdn);
-                    /* dn is not dup'ed in slapi_sdn_new_dn_passin.
-                     * It's set to bdn and put in the dn cache. */
-                    /* don't free dn */
-                    sdn = slapi_sdn_new_dn_passin(dn);
-                    bdn = backdn_init(sdn, temp_id, 0);
-                    myrc = CACHE_ADD(&inst->inst_dncache, bdn, NULL);
-                    if (myrc) {
-                        backdn_free(&bdn);
-                        slapi_log_err(SLAPI_LOG_CACHE, "ldbm_back_ldbm2ldif",
-                                      "%s is already in the dn cache (%d)\n",
-                                      dn, myrc);
-                    } else {
-                        CACHE_RETURN(&inst->inst_dncache, &bdn);
-                        slapi_log_err(SLAPI_LOG_CACHE, "ldbm_back_ldbm2ldif",
-                                      "entryrdn_lookup_dn returned: %s, "
-                                      "and set to dn cache\n",
-                                      dn);
-                    }
-                }
-                ep->ep_entry = slapi_str2entry_ext(dn, NULL, data.dptr,
-                                                   str2entry_options | SLAPI_STR2ENTRY_NO_ENTRYDN);
-                slapi_ch_free_string(&rdn);
-            }
-        } else {
-            ep->ep_entry = slapi_str2entry(data.dptr, str2entry_options);
-        }
-        slapi_ch_free(&(data.data));
+    PR_ASSERT(rc > 0);
+    rc = 0;
+    if ((*expargs->cnt) % 1000 == 0) {
+        int percent;
 
-        if ((ep->ep_entry) != NULL) {
-            ep->ep_id = temp_id;
+        if (expargs->idl) {
+            percent = (expargs->idindex * 100 / expargs->idl->b_nids);
         } else {
-            slapi_log_err(SLAPI_LOG_WARNING, "ldbm_back_ldbm2ldif", "Skipping "
-                                                                    "badly formatted entry with id %lu\n",
-                          (u_long)temp_id);
-            backentry_free(&ep);
-            continue;
+            percent = (expargs->ep->ep_id * 100 / expargs->lastid);
         }
-
-        eargs.ep = ep;
-        eargs.idindex = idindex;
-        eargs.cnt = &cnt;
-        eargs.lastcnt = &lastcnt;
-        rc = export_one_entry(li, inst, &eargs);
-        backentry_free(&ep);
+        if (expargs->task) {
+            slapi_task_log_status(expargs->task,
+                                  "%s: Processed %d entries (%d%%).",
+                                  inst->inst_name, *expargs->cnt, percent);
+            slapi_task_log_notice(expargs->task,
+                                  "%s: Processed %d entries (%d%%).",
+                                  inst->inst_name, *expargs->cnt, percent);
+        }
+        slapi_log_err(SLAPI_LOG_INFO, "export_one_entry", "export %s: Processed %d entries (%d%%).\n",
+                      inst->inst_name, *expargs->cnt, percent);
+        *expargs->lastcnt = *expargs->cnt;
     }
-    /* DB_NOTFOUND -> successful end */
-    if (return_value == DB_NOTFOUND)
-        return_value = 0;
+bail:
+    slapi_ch_free(&(data.data));
+    return rc;
+}
 
-    /* done cycling thru entries to write */
-    if (lastcnt != cnt) {
-        if (task) {
-            slapi_task_log_status(task,
-                                  "%s: Processed %d entries (100%%).",
-                                  inst->inst_name, cnt);
-            slapi_task_log_notice(task,
-                                  "%s: Processed %d entries (100%%).",
-                                  inst->inst_name, cnt);
-        }
-        slapi_log_err(SLAPI_LOG_INFO, "ldbm_back_ldbm2ldif",
-                      "export %s: Processed %d entries (100%%).\n",
-                      inst->inst_name, cnt);
-    }
-bye:
-    if (idl) {
-        idl_free(&idl);
-    }
-    if (dbc) {
-        dbc->c_close(dbc);
-    }
+/*
+ * ldbm_back_ldbm2ldif - backend routine to convert database to an
+ * ldif file.
+ * (reunified at last)
+ */
+#define LDBM2LDIF_BUSY (-2)
+int
+ldbm_back_ldbm2ldif(Slapi_PBlock *pb)
+{
+    struct ldbminfo *li;
+    int32_t dump_replica = 0;
+    int32_t run_from_cmdline = 0;
+    int32_t we_start_the_backends = 0;
+    int task_flags;
 
-    dblayer_release_id2entry(be, db);
+    slapi_pblock_get(pb, SLAPI_PLUGIN_PRIVATE, &li);
+    slapi_pblock_get(pb, SLAPI_TASK_FLAGS, &task_flags);
+    run_from_cmdline = (task_flags & SLAPI_TASK_RUNNING_FROM_COMMANDLINE);
 
-    if (fd >= 0) {
-        close(fd);
+    dump_replica = slapi_pblock_get_ldif_dump_replica(pb);
+    if (run_from_cmdline) {
+        li->li_flags |= SLAPI_TASK_RUNNING_FROM_COMMANDLINE;
+        if (!dump_replica) {
+            we_start_the_backends = 1;
+        }
     }
 
-    slapi_log_err(SLAPI_LOG_TRACE, "ldbm_back_ldbm2ldif", "<=\n");
+    if (we_start_the_backends) {
+        /* No ldbm be's exist until we process the config information. */
 
-    if (we_start_the_backends && NULL != li) {
-        if (0 != dblayer_close(li, DBLAYER_EXPORT_MODE)) {
-            slapi_log_err(SLAPI_LOG_ERR,
-                          "ldbm_back_ldbm2ldif", "db2ldif: Failed to close database\n");
-        }
-    }
+        /*
+         * Note that we should only call this once. If we're
+         * dumping several backends then it gets called multiple
+         * times and we get warnings in the error log like this:
+         *   WARNING: ldbm instance userRoot already exists
+         */
 
-    if (!run_from_cmdline && inst && (LDBM2LDIF_BUSY != return_value)) {
-        instance_set_not_busy(inst);
+        if (dblayer_setup(li)) {
+            slapi_log_err(SLAPI_LOG_CRIT, "ldbm_back_ldbm2ldif", "dblayer_setup failed\n");
+            return -1;
+        }
     }
 
-    ldbm_back_free_incl_excl(include_suffix, exclude_suffix);
-    idl_free(&(eargs.pre_exported_idl));
+    dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
 
-    return (return_value);
+    return priv->dblayer_db2ldif_fn(pb);;
 }
 
 
@@ -1736,7 +906,12 @@ ldbm_back_ldbm2index(Slapi_PBlock *pb)
     if (run_from_cmdline) {
         /* No ldbm backend exists until we process the config info. */
         li->li_flags |= SLAPI_TASK_RUNNING_FROM_COMMANDLINE;
-        ldbm_config_load_dse_info(li);
+
+        if (dblayer_setup(li)) {
+            slapi_log_err(SLAPI_LOG_CRIT, "ldbm_back_init", "dblayer_init failed\n");
+            return return_value;
+        }
+
     }
 
     inst = ldbm_instance_find_by_name(li, instance_name);
@@ -1905,7 +1080,7 @@ ldbm_back_ldbm2index(Slapi_PBlock *pb)
                                   "ldbm_back_ldbm2index", "%s: Indexing attribute: %s\n",
                                   inst->inst_name, attrs[i] + 1);
                 }
-                dblayer_erase_index_file(be, ai, i /* chkpt; 1st time only */);
+                dblayer_erase_index_file(be, ai, PR_TRUE, i /* chkpt; 1st time only */);
                 break;
             case 'T': /* VLV Search to index */
                 vlvip = vlv_find_searchname((attrs[i]) + 1, be);
@@ -2726,9 +1901,6 @@ ldbm_exclude_attr_from_export(struct ldbminfo *li, const char *attr, int dump_un
  * (604921) Support a database uprev process any time post-install
  */
 
-int upgradedb_core(Slapi_PBlock *pb, ldbm_instance *inst);
-int upgradedb_copy_logfiles(struct ldbminfo *li, char *destination_dir, int restore);
-int upgradedb_delete_indices_4cmd(ldbm_instance *inst, int flags);
 
 /*
  * ldbm_back_upgradedb -
